<template>
  <div>
    <v-card
      style="min-height: 550px; height: 655px; position: absolute; top: 8%;"
    >
      <v-list-item>
        <v-list-item-title class="headline">Receiver</v-list-item-title>
      </v-list-item>
      <v-divider></v-divider>
      <v-container
        id="scroll-target"
        style="height: 550px; width: 500px;"
        class="overflow-y-auto"
      >
        <v-row
          v-if="messages.length > 0"
          v-scroll:#scroll-target="scrollTarget"
          align="center"
          justify="center"
        >
          <v-list-item
            v-for="(message, index) in messages[0]"
            :key="index"
            :style="
              message.sender === user.id
                ? 'display: flex; justify-content: flex-end'
                : ''
            "
          >
            <v-chip
              :id="index === messages[0].length - 1 ? 'goHere' : ''"
              ripple
              class="ma-2"
              color="blue"
            >
              <span style="display: inline;">
                {{ message.body }}
              </span>
            </v-chip>
          </v-list-item>
        </v-row>
      </v-container>
      <v-item-group>
        <v-item
          ><v-text-field
            v-model="messageBody"
            outlined
            style="position: relative; bottom: 0;"
            label="Enter new message"
            @keyup.enter="sendMessage"
          >
            <v-icon v-if="!messageBody" slot="append" medium
              >fas fa-search</v-icon
            >
            <v-icon v-else slot="append" medium @click="sendMessage"
              >fas fa-paper-plane</v-icon
            >
          </v-text-field></v-item
        >
      </v-item-group>
    </v-card>
  </div>
</template>

<script>
import { mapActions, mapState } from 'vuex'

export default {
  name: 'Index',
  data: () => ({
    messageBody: null
  }),
  watch: {
    messages() {
      this.$nextTick(function() {
        document.getElementById('goHere').scrollIntoView()
      })
    }
  },
  computed: {
    ...mapState('chat', ['messages']),
    ...mapState('authentication', ['user'])
  },
  created() {
    this.getChatMessages()
  },
  mounted() {},
  methods: {
    ...mapActions('chat', ['getChatUser', 'getChatFacilitator']),
    async getChatMessages() {
      if (this.$route.name === 'user-chat') {
        await this.getChatUser(this.$route.params.id)
      } else {
        await this.getChatFacilitator(this.$route.params.id)
      }
    },
    sendMessage() {
      if (this.messageBody) {
        const messageObject = {
          messageBody: this.messageBody,
          id: this.$route.params.id
        }
        if (this.$route.name === 'user-chat') {
          this.$store
            .dispatch('chat/addMessageUser', messageObject)
            .then(res => {
              if (res.id) {
                this.messageBody = null
              }
            })
            .catch(err => console.log(err))
        } else {
          this.$store
            .dispatch('chat/addMessageFacilitator', messageObject)
            .then(res => {
              if (res.id) {
                this.messageBody = null
              }
            })
            .catch(err => console.log(err))
        }
      }
    },
    scrollTarget() {}
  }
}
</script>

<style scoped></style>
